<?php
/*
Plugin Name:Comment Gallery
Description:コメント付きギャラリー実験
Version: 1.0
Author: Y.ikeda
Author URI: http://55w.jp
*/


add_shortcode('comment_gallery', 'comment_gallery_shortcode');
function comment_gallery_shortcode($attr){
	global $post,$wp_locale;
	extract(shortcode_atts(array(
		'id'         => $post->ID,
		'columns'    => 3,
		'size'       => 'thumbnail',
	), $attr));	
	$attachments = get_children( array('post_parent' => $id, 'post_status' => 'inherit', 'post_type' => 'attachment', 'post_mime_type' => 'image'));
	if ( empty($attachments) )
		return '';
	$html = "";
	
	$div  = "<div id='comment_gallery_div'>\n<div id='comment_gallery_imagearea'>___WRAPIMAGE___</div>___WRAPCOMMENT___<div id='comment_gallery_thumbarea'>___WRAPDIV___\n</div></div>";
	$dl   = "<dl id='comment_gallery_dl'>\n___WRAPDL___\n</dl>";

	$data ="";
	foreach($attachments as $id => $attachment){
		$src   = wp_get_attachment_image_src($id);
		if(!$data){$image_first_id=$id;}
		$image = "<img src='{$src[0]}' class='gallery_item gallery_item_{$id}'>";
		$data .= "<dd>{$image}<input type='hidden' value='{$id}'></dd>";
	}
	$image_first_src = wp_get_attachment_image_src($image_first_id,'medium');
	$g_comments = get_post_meta($image_first_id,'img_comment');
	$cmt_list ="<ul>";
	foreach($g_comments as $g_comment){
		$cmt_list .= "<li>{$g_comment}</li>";
	}
	$cmt_list .= "</ul>";
	$img  = "<img src='{$image_first_src[0]}' class='gallery_item_area'>";
	$cmt  = "<div id='comment_gallery_cmt'><div id='comment_gallery_cmt_area'>{$cmt_list}</div><input type='hidden' name='img_id' id='img_id' value='{$image_first_id}'><input type='text' name='meta_form' id='meta_form'><input type='submit' id='post_cmt'></div>";	
	$html = preg_replace('/___WRAPDIV___/mu',$dl,$div);
	$html = preg_replace('/___WRAPCOMMENT___/mu',$cmt,$html);	
	$html = preg_replace('/___WRAPIMAGE___/mu',$img,$html);	
	$html = preg_replace('/___WRAPDL___/mu',$data,$html);
	
	
	return $html;
}

add_action("wp_print_styles","comment_gallery_load_css");
function comment_gallery_load_css(){
	if(is_singular()){wp_enqueue_style('coment_gallery_css', plugin_dir_url( __FILE__ ) . 'coment_gallery.css');}
}
add_action("wp_print_scripts","comment_gallery_load_jq");
function comment_gallery_load_jq(){
	if(is_singular()){
		wp_enqueue_script('jquery');
		}
	}

add_action("wp_footer","comment_gallery_load_js");
function comment_gallery_load_js(){
	if(is_singular()){
$j_path = plugin_dir_url( __FILE__ );
$blogurl = get_bloginfo('home');
echo "
<script type='text/javascript'>
jQuery(function () {
	jQuery('#post_cmt').click(function(){
		jQuery.post('{$j_path}g_post.php',{
			mode:'post_meta',
			img_id:jQuery('#img_id').val(),
			text:jQuery('#meta_form').val(),
			url:'{$blogurl}'
		},function(data){
			jQuery('#comment_gallery_cmt_area').html(data);
		});
	});
	
	jQuery('#comment_gallery_dl img').click(function(){
		var img_id = jQuery(this).siblings('input').val();
		jQuery.post('{$j_path}g_post.php',{
			mode:'load_img',
			img_id:img_id
		},function(data){
			jQuery('.gallery_item_area').attr('src',data);
			jQuery('#img_id').val(img_id);
			jQuery.post('{$j_path}g_post.php',{
				mode:'read_meta',
				img_id:img_id
			},function(data){
				jQuery('#comment_gallery_cmt_area').html(data);
			});	
		});	
	
	

	});
});	

</script>
		";
	}
}

?>